C     PROGRAM TDE53D2
      DOUBLE PRECISION YN,Y,RAB,YT,DELY(2),
     1                 XN,H,XK,H0,Q
      DIMENSION YN(2),Y(2),RAB(446),YT(2)
      DOUBLE PRECISION AY1(13),AY2(13),AV1(12),AV2(12),
     1                 BY1(13),BY2(13),BV1(12),BV2(12),
     2                 YA(2),YB(2),INA(2),INB(2)
      COMMON/FIRST /AY1,AY2,AV1,AV2,YA,INA
     1      /SECOND/BY1,BY2,BV1,BV2,YB,INB      
C
C    AY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 1 INTERVAL 
C    AY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 1 INTERVAL 
C
C    AV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 1 INTERVAL 
C    AV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 1 INTERVAL 
C
C    BY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 2 INTERVAL 
C    BY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 2 INTERVAL 
C
C    BV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 2 INTERVAL 
C    BV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 2 INTERVAL 
C       
C     YA - COORDINATES AT THE END OF 1 INTERVAL
C     YB - COORDINATES AT THE END OF 2 INTERVAL
C
C    INA - BOUNDARIES OF 1 INTERVAL
C    INB - BOUNDARIES OF 2 INTERVAL
C
      EXTERNAL F,FTREAT
      M=2
      Q=0.5D0
      XN=0.
      YN(1)= COS(Q)+1.D0
      YN(2)=-SIN(Q)+1.D0
      XK=1.D0
      H0=0.5D0
      YT(1)=COS(Q*(2.D0*XK-1.D0))+1.D0
      YT(2)=SIN(Q*(2.D0*XK-1.D0))+1.D0
      K=11
      IMAX=13
C      DO 42 INIAP0=1,2
      INIAPR=1
      H=H0
      CALL DE53D(F,FTREAT,M,XN,YN,XK,K,INIAPR,IMAX,H,Y,
     1           RAB)
      DELY(1)=YT(1)-Y(1)
      DELY(2)=YT(2)-Y(2)
      PRINT 47
      PRINT 35, H0,K,INIAPR,IMAX
      PRINT 60, Y,YT,DELY
      PRINT 48
C   42 CONTINUE
C________________________________________________________________
C
      KP1=K+1
      KP2=K+2
      PRINT 110,INA
      PRINT  10,YA
      PRINT 150
      PRINT 85,(J-1,AY1(J),AV1(J),J=1,KP1), KP1,AY1(KP2)
      PRINT 160
      PRINT 85,(J-1,AY2(J),AV2(J),J=1,KP1), KP1,AY2(KP2)
C
C------------------------------------------------------------------
C
      PRINT 111,INB
      PRINT  11,YB
      PRINT 150
      PRINT 85,(J-1,BY1(J),BV1(J),J=1,KP1), KP1,BY1(KP2)
      PRINT 160
      PRINT 85,(J-1,BY2(J),BV2(J),J=1,KP1), KP1,BY2(KP2)
      STOP
   10 FORMAT(1X,'COORDINATES AT THE END OF 1 SEGMENT:'
     1      /1X,'YA=',2D25.16/)
   11 FORMAT(1X,'COORDINATES AT THE END OF 2 SEGMENT:'
     1      /1X,'YB=',2D25.16/)
   85 FORMAT(5X,I2,5X,2D25.16)
  110 FORMAT(/1X,'CHEBYSHEV COEFFICIENTS  AT 1 SEGMENT'/
     1        1X,'INA(1)=',D25.16,5X,'INA(2)=',D25.16/)
  111 FORMAT(/1X,'CHEBYSHEV COEFFICIENTS  AT 2 SEGMENT'/
     1        1X,'INB(1)=',D25.16,5X,'INB(2)=',D25.16/)
  150 FORMAT('   Number of',2X,'Coefficients'
     *       ' for 1 coordinate and 1 velocity component'/  
     1        14X,51(1H-)/
     2       ' coefficient',9X,'coordinate',17X,'velocity'/         
     3        1X,64(1H-)/)
  160 FORMAT(/'   Number of',2X,'Coefficients'
     *       ' for 2 coordinate and 2 velocity component'/  
     1        14X,51(1H-)/
     2       ' coefficient',9X,'coordinate',17X,'velocity'/         
     3        1X,64(1H-)/)
   47 FORMAT( 1X,64(1H-)/)
   48 FORMAT(/1X,64(1H*)/) 
   35 FORMAT(/1X,'H0=',D25.16,3X,'K=',I2,3X,'INIAPR=',I1,3X,'IMAX=',I2)
   60 FORMAT(1X,'Y =',2D25.16/1X,'YT=',2D25.16/1X,'DELTA Y  =',2D25.16)
      END

      SUBROUTINE F(X,Y,Z,M)
      DOUBLE PRECISION X,Y(2),Z(2),R,Q
      Q=0.5D0
      R =2.D0*X-1.D0
      Z(1)=-2.D0*Q*(Y(2)-1.D0)+(1.D0-DEXP(1.D0-Y(1)+DCOS(Q*R)))/(1.D0+X) 
      Z(2)= 2.D0*Q*(Y(1)-1.D0)+(1.D0-DEXP(1.D0-Y(2)+DSIN(Q*R)))/(1.D0+X) 
      RETURN
      END

      SUBROUTINE FTREAT(S,XI,XE,Y,AY,ADY,M,KP1,KP2)
      INTEGER S,M,KP1,KP2
      DOUBLE PRECISION XI,XE,Y,AY,ADY
      DIMENSION AY(M,KP2),ADY(M,KP1),Y(M)
      DOUBLE PRECISION AY1(13),AY2(13),AV1(12),AV2(12),
     1                 BY1(13),BY2(13),BV1(12),BV2(12),
     2                 YA(2),YB(2),INA(2),INB(2)
      COMMON/FIRST /AY1,AY2,AV1,AV2,YA,INA
     1      /SECOND/BY1,BY2,BV1,BV2,YB,INB      
C
C    AY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 1 INTERVAL 
C    AY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 1 INTERVAL 
C
C    AV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 1 INTERVAL 
C    AV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 1 INTERVAL 
C
C    BY1 - CHEBYSHEV COEFFICIENTS FOR 1 COORDINATE AT 2 INTERVAL 
C    BY2 - CHEBYSHEV COEFFICIENTS FOR 2 COORDINATE AT 2 INTERVAL 
C
C    BV1 - CHEBYSHEV COEFFICIENTS FOR 1 VELOCITY COMPONENT AT 2 INTERVAL 
C    BV2 - CHEBYSHEV COEFFICIENTS FOR 2 VELOCITY COMPONENT AT 2 INTERVAL 
C       
C     YA - COORDINATES AT THE END OF 1 INTERVAL
C     YB - COORDINATES AT THE END OF 2 INTERVAL
C
C    INA - BOUNDARIES OF 1 INTERVAL
C    INB - BOUNDARIES OF 2 INTERVAL
C
      GO TO (10,30),S
C
C--------SAVING CHEBYSHEV COEFFICIENTS FOR  COORDINATES AND
C--------     VELOCITY COMPONENTS AT THE FIRST INTERVAL  
C
   10 DO 15 I=1,KP2
      AY1(I)=AY(1,I)
   15 AY2(I)=AY(2,I)
C
      DO 20 I=1,KP1
      AV1(I)=ADY(1,I)
   20 AV2(I)=ADY(2,I)
C
C--------SAVING COORDINATES AT THE END OF 1 INTERVAL
      YA(1)=Y(1)
      YA(2)=Y(2)
C
C--------SAVING BOUNDARIES OF 1 INTERVAL
      INA(1)=XI
      INA(2)=XE
      RETURN
C
C--------SAVING CHEBYSHEV COEFFICIENTS FOR  COORDINATES AND
C--------     VELOCITY COMPONENTS AT THE SECOND INTERVAL  
C
   30 DO 35 I=1,KP2
      BY1(I)=AY(1,I)
   35 BY2(I)=AY(2,I)
C
      DO 40 I=1,KP1
      BV1(I)=ADY(1,I)
   40 BV2(I)=ADY(2,I)
C
C--------SAVING COORDINATES AT THE END OF 2 INTERVAL
      YB(1)=Y(1)
      YB(2)=Y(2) 
C
C--------SAVING BOUNDARIES OF 2 INTERVAL
      INB(1)=XI
      INB(2)=XE
      RETURN
      END
